public class FunzionePolinomiale implements Funzione{

	private double[] a;

	public FunzionePolinomiale(double[] a){
		this.a=new double[a.length];
		for(int i=0;i<a.length;i++){
			this.a[i]=a[i];
		}
	}

	public double valore(double x){
		double valore=0;
		for(int i=0;i<a.length;i++){
			valore+=a[i]*Math.pow(x,i);
		}
		return valore;
	}

	public Funzione derivata(){
		double[] b;
		if(this.a.length==1){//Funzione polinomiale costante
			b=new double[1];
			b[0]=0; // Derivata nulla
		}else{
			b=new double[this.a.length-1];
			for(int i=0;i<b.length;i++){
				b[i]=a[i+1]*(i+1);
			}
		}
		return new FunzionePolinomiale(b);
	}

	public String toString(){
			String s="";
			for(int i=a.length-1;i>=0;i--){
				s+=a[i]+"*x^"+i;
				if(i>0)
					s+="+";
			}
			return s;
	}



}