import fond.io.*;

public class ProvaFunzione{

	public static void main(String[] args){
		OutputWindow out=new OutputWindow();
		InputWindow in=new InputWindow();

		out.writeln("Inserisci una funzione polinomiale.");
		int n=in.readInt("Grado del polinomio");
		double[] coeff=new double[n+1];

		for(int i=0;i<coeff.length;i++){
			coeff[i]=in.readDouble("Inserisci il coefficiente del termine di grado "+i);
		}

		Funzione g=new FunzionePolinomiale(coeff);
		Funzione gdev=g.derivata();
		out.writeln("Funzione polinomiale inserita: g(x)="+g);
		out.writeln("Derivata di g(x): g'(x)="+gdev);

		out.writeln("Inserisci una funzione sinusoidale della forma f(x)=a*sin(bx+c).");
		double a=in.readDouble("Coefficiente a");
		double b=in.readDouble("Coefficiente b");
		double c=in.readDouble("Coefficiente c");

		Funzione h=new FunzioneSinusoidale(a,b,c);
		Funzione hdev=h.derivata();
		out.writeln("Funzione sinusoidale inserita: h(x)="+h);
		out.writeln("Derivata di h(x): h'(x)="+hdev);


		Funzione f1=new SommaDiFunzioni(g,h);
		Funzione f2=new ProdottoDiFunzioni(g,h);
		Funzione f1dev=f1.derivata();
		Funzione f2dev=f2.derivata();

		out.writeln("Funzione somma: f1(x)=g(x)+h(x)="+f1);
		out.writeln("Derivata di f1(x): f1'(x)="+f1dev);

		out.writeln("Funzione somma: f2(x)=g(x)*h(x)="+f2);
		out.writeln("Derivata di f2(x): f2'(x)="+f2dev);

		out.writeln("Adesso inserisci un valore di x.");
		double x=in.readDouble("Valore di x");

		out.writeln("g("+x+")="+g.valore(x));
		out.writeln("h("+x+")="+h.valore(x));

		out.writeln("f1("+x+")="+f1.valore(x));
		out.writeln("f2("+x+")="+f2.valore(x));

		out.writeln("g'("+x+")="+gdev.valore(x));
		out.writeln("h'("+x+")="+hdev.valore(x));

		out.writeln("f1'("+x+")="+f1dev.valore(x));
		out.writeln("f2'("+x+")="+f2dev.valore(x));




	}



}